# Interface PresentableAttributes

Feature attributes that have been formatted for display.

interface PresentableAttributes {
_handles: Handles<unknown, ResourceHandle>;
_originalMap: ObservableMap<string, string>;
[toStringTag]: "ObservableMap";
@eventTypes: MapEvents<string, string>;
get size(): number;
[iterator](): MapIterator<[string, string]>;
clear(): void;
delete(key: string): boolean;
destroy(): void;
emit<Type>(type: Type, event?: MapEvents<string, string>[Type]): boolean;
entries(): MapIterator<[string, string]>;
forEach(callbackfn: ((value: string, key: string, map: Map<string, string>) => void), thisArg?: unknown): void;
get(key: string): string;
has(key: string): boolean;
keys(): MapIterator<string>;
on<Type>(type: Type, listener: EventedCallback<MapEvents<string, string>[Type]>): IHandle;
set(key: string, value: string): this;
toJSON(): unknown;
values(): MapIterator<string>;
}

#### Hierarchy (view full)

- ReadOnlyMap<string, string>
  - PresentableAttributes

#####
Index

### Properties

_handles
_originalMap
[toStringTag]
@eventTypes

### Accessors

size

### Methods

[iterator]
clear
delete
destroy
emit
entries
forEach
get
has
keys
on
set
toJSON
values

##
Properties

### `Protected` `Readonly`_handles

_handles: Handles<unknown, ResourceHandle>

Inherited from ReadOnlyMap._handles

### `Protected` `Readonly`_originalMap

_originalMap: ObservableMap<string, string>

The underlying map that this object is delegating to.

Inherited from ReadOnlyMap._originalMap

### `Readonly`[toStringTag]

[toStringTag] = "ObservableMap"

Used by Object.toString().

Inherited from ReadOnlyMap.[toStringTag]

### @eventTypes

@eventTypes: MapEvents<string, string>

#### Deprecated

Do not directly reference this property. Use EventNames and EventTypes helpers from @arcgis/core/Evented.

Inherited from ReadOnlyMap.@eventTypes

##
Accessors

### size

- get size(): number

- The number of elements.

  #### Returns number

  Inherited from ReadOnlyMap.size

##
Methods

### [iterator]

- [iterator](): MapIterator<[string, string]>

- Returns the `[key, value]` pairs for each element in the map in insertion order.

  #### Returns MapIterator<[string, string]>

  Inherited from ReadOnlyMap.[iterator]

### clear

- clear(): void

- Removes all elements.

  #### Returns void

  Inherited from ReadOnlyMap.clear

### delete

- delete(key): boolean

- Removes the specified element.

  #### Parameters

  - key: string

    The element's key.

  #### Returns boolean

  True if an element was deleted, otherwise false.

  Inherited from ReadOnlyMap.delete

### destroy

- destroy(): void

- #### Returns void

  Inherited from ReadOnlyMap.destroy

### emit

- emit<Type>(type, event?): boolean

- Emits an event on the instance. This method should only be used when creating subclasses of this class.

  #### Type Parameters

  - Type extends EventNames<PresentableAttributes>

  #### Parameters

  - type: Type

    The name of the event.

  - `Optional` event: MapEvents<string, string>[Type]

    The event payload.

  #### Returns boolean

  `true` if a listener was notified

  #### Since

  4.5

  Inherited from ReadOnlyMap.emit

### entries

- entries(): MapIterator<[string, string]>

- Returns the `[key, value]` pairs for each element in the map in insertion order.

  #### Returns MapIterator<[string, string]>

  Inherited from ReadOnlyMap.entries

### forEach

- forEach(callbackfn, thisArg?): void

- Executes a provided function once per each key/value pair in the map.

  #### Parameters

  - callbackfn: ((value: string, key: string, map: Map<string, string>) => void)

    Function to execute for each element.

    - - (value, key, map): void

      - #### Parameters

        - value: string
        - key: string
        - map: Map<string, string>

        #### Returns void

  - `Optional` thisArg: unknown

    Value to use as `this` when executing callback.

  #### Returns void

  Inherited from ReadOnlyMap.forEach

### get

- get(key): string

- Returns a specified element from the Map object. If the value that is associated to the provided key is an object, then you will get a reference to that object and any change made to that object will effectively modify it inside the Map.

  #### Parameters

  - key: string

  #### Returns string

  Returns the element associated with the specified key. If no element is associated with the specified key, undefined is returned.

  Inherited from ReadOnlyMap.get

### has

- has(key): boolean

- Indicates whether or not an element with the specified key exists.

  #### Parameters

  - key: string

    The key to test for.

  #### Returns boolean

  Inherited from ReadOnlyMap.has

### keys

- keys(): MapIterator<string>

- Returns the keys for each element in the map in insertion order.

  #### Returns MapIterator<string>

  Inherited from ReadOnlyMap.keys

### on

- on<Type>(type, listener): IHandle

- Registers an event handler on the instance. Call this method to hook an event with a listener.

  #### Type Parameters

  - Type extends EventNames<PresentableAttributes>

  #### Parameters

  - type: Type

    An event or an array of events to listen for.

  - listener: EventedCallback<MapEvents<string, string>[Type]>

    The function to call when the event fires.

  #### Returns IHandle

  Returns an event handler with a `remove()` method that should be called to stop listening for the event(s).

  Property | Type | Description
  --- | --- | ---
  remove | Function | When called, removes the listener from the event.

  #### Example

      view.on("click", function(event){
        // event is the event handle returned after the event fires.
        console.log(event.mapPoint);
      });

  Inherited from ReadOnlyMap.on

### set

- set(key, value): this

- Adds a new element with a specified key and value to the Map. If an element with the same key already exists, the element will be updated.

  #### Parameters

  - key: string
  - value: string

  #### Returns this

  Inherited from ReadOnlyMap.set

### toJSON

- toJSON(): unknown

- Returns a serializable representation of the map.

  #### Returns unknown

  Inherited from ReadOnlyMap.toJSON

### values

- values(): MapIterator<string>

- Returns the values for each element in the map in insertion order.

  #### Returns MapIterator<string>

  Inherited from ReadOnlyMap.values